
#include "mpi-test.h"

double Ring ( int iSIZE , int TIMES)
{
    char* Buffer[4];
    int iNumberOfProc, iMyRank, iLeft, iRight, iSize, iCount;
    double dBeginTime, dEndTime, Rate, dUsedTime, dTime, dLatency;
    MPI_Status MPIStatus;
	MPI_Request Requests[4];
	int pool_size,rank,i_am_the_master,remote_rank;
	MPI_Comm comm = MPI_COMM_WORLD;
	MPI_Status Status;
	int i;

    MPI_Comm_size (comm,&iNumberOfProc );
    MPI_Comm_rank (comm,&iMyRank );

	rank = iMyRank;
	i_am_the_master = (rank == 0);
	pool_size = iNumberOfProc;

    iLeft = ( iMyRank + iNumberOfProc - 1) % iNumberOfProc;
    iRight = ( iMyRank + 1 ) % iNumberOfProc;
	
    for(i = 0; i < 4; i ++)
    	if((Buffer[i] = (char *) malloc (iSIZE)) == NULL)
			finish("Can't allocate memory");

    if ( Buffer == NULL )
		finish("Can't allocate memory");    

	iSize = iSIZE;
    MPI_Barrier(comm);
    dBeginTime = Wtime();

        for ( iCount = 0; iCount < TIMES; iCount++ )
        {
				MPI_Isend (Buffer[0], iSize, MPI_CHAR, iLeft,
                          iTAG, MPI_COMM_WORLD, &Requests[0]);
				MPI_Irecv (Buffer[3], iSize, MPI_CHAR, iRight,
                          iTAG, MPI_COMM_WORLD, &Requests[3]);
				MPI_Wait(&Requests[0],&Status);
				MPI_Wait(&Requests[3],&Status);				
				MPI_Isend (Buffer[2], iSize, MPI_CHAR, iRight,
                          iTAG, MPI_COMM_WORLD, &Requests[2]);
				MPI_Irecv (Buffer[1], iSize, MPI_CHAR, iLeft,
                          iTAG, MPI_COMM_WORLD, &Requests[1]);
				MPI_Wait(&Requests[2],&Status);
				MPI_Wait(&Requests[1],&Status);				

        } /* End of for */

	MPI_Barrier(comm);   
	dEndTime = Wtime ( );
	dUsedTime = dEndTime - dBeginTime;

		/* rate is megabytes per second */
	Rate = ((double) TIMES * 2.0 * iSize)/(dUsedTime*MEGABYTE);

	for(i = 0; i < 4; i ++)
		free(Buffer[i]);

	  return(Rate);

} /* End of Ring ( ) */



